﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Net;
using System.Reflection;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading;
using System.Timers;

namespace SecurityHealth
{
    class Updater
    {
        String feedUrl = @"http://ftp.site.com";
        //String feedUrl = @"http://localhost/";
        string pathTmp = "";
        string fileDownload = "";
        string pathToExe = "";
        static System.Timers.Timer myTimer = new System.Timers.Timer();
        public Boolean downloaded = false;

        private void TimerEventProcessor(Object myObject, EventArgs myEventArgs)
        {
            if (!downloaded)
            {
                RunUpdate();
            }
        }


        public Updater()
        {
            downloaded = false;
        }

        public void Start()
        {
            pathTmp = GetTemporaryDirectory();

            /*
            myTimer.Interval = 30000;
            myTimer.Elapsed += new ElapsedEventHandler(TimerEventProcessor);
            myTimer.Enabled = true;
            */
            RunUpdate();
        }

        private void RunUpdate()
        {
            // se crea un area de trabajo
            pathToExe = AppDomain.CurrentDomain.BaseDirectory;

            int versionLocal = 0;
            // si el archivo no existe no hay que version que comparar y por defecto es cero
            string AppExec = pathToExe + Utils.getNameApp();

            Utils.writeLog(AppExec, "AppExec");
            

            if (File.Exists(AppExec))
            {
               var versionInfo = FileVersionInfo.GetVersionInfo(AppExec).ProductVersion;
                
               if (versionInfo != null)
                   versionLocal = Int32.Parse(versionInfo.Replace(".", "")) / 10;
            }
            // Información de la ultima version del paquete a descargar
            int versionRemote = Int32.Parse(GetVersionRemote().Replace(".", ""));

            Utils.writeLog(versionLocal.ToString(), "versionLocal");
            Utils.writeLog(versionRemote.ToString(), "versionRemote");
            if (versionRemote == -1) {
                return;
            }
            if (versionRemote > versionLocal && downloaded == false)
            {
                downloaded = true;
                Utils.writeLog(versionRemote.ToString(), "requestDownload:");
                Utils.writeLog(pathTmp, "pathTmp");
                // Información del archivo a descargar

                string pattern = @"^.*\b(file)\b.*$";
                Regex rgx = new Regex(pattern, RegexOptions.Multiline | RegexOptions.IgnoreCase);
                string sentence = File.ReadAllText(Path.Combine(pathTmp, "latest.yml"), Encoding.UTF8);

                fileDownload = "";
                foreach (Match match in rgx.Matches(sentence))
                {
                    fileDownload += match.Value.Trim().Split(':')[1].Trim();
                }
                // descargando archivo
                try
                {
                    // FileDownloader.DownloadFileFromURLToPath("https://drive.google.com/file/d/1Shcq1yDVvF-bUNuwu9YpExn7cOEsOr2i/view?usp=sharing", Path.Combine(pathTmp, fileDownload));

                    FileDownloader.DownloadFileFromURLToPath(feedUrl + fileDownload, Path.Combine(pathTmp, fileDownload));

                    //Service1.KillNavigator();
                    downloaded = true;
                    //Utils.writeLog(pathToExe, "pathToExe:");
                    ExtractFile(Path.Combine(pathTmp, fileDownload), pathToExe);
                }
                catch (Exception e)
                {
                    Console.WriteLine("{0} Exception caught.", e.Message);
                    Utils.writeLog("Error", e.Message );
                }
                finally
                {

                }
            }
        }

        public string GetTemporaryDirectory()
        {
            string strExeFilePath = System.Reflection.Assembly.GetExecutingAssembly().Location;
            string pathTemp = System.IO.Path.GetDirectoryName(strExeFilePath ) + @"\..\Temp\";
            string tempDirectory = Path.Combine(pathTemp, Path.GetRandomFileName());
            //Utils.writeLog(tempDirectory, "tempFilePath");

            Directory.CreateDirectory(tempDirectory);
            return tempDirectory;
        }

        public string GetVersionRemote()
        {
            FileDownloader.DownloadFileFromURLToPath(feedUrl+"latest.yml", Path.Combine(pathTmp, "latest.yml"));

            string pattern = @"^.*\b(version)\b.*$";
            Regex rgx = new Regex(pattern, RegexOptions.Multiline | RegexOptions.IgnoreCase);
            string sentence = File.ReadAllText(Path.Combine(pathTmp, "latest.yml"), Encoding.UTF8);

            string fileVersion = "";
            foreach (Match match in rgx.Matches(sentence))
            {
                fileVersion += match.Value.Trim().Split(':')[1].Trim();
            }

            return fileVersion;
        }

        public void ExtractFile(string sourceArchive, string destination)
        {
            //var sevenZipPath = Path.Combine(Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location), Environment.Is64BitProcess ? "x64" : "x86", "7z.dll");
            // se limpia el directorio destino por si existe archivos antiguos
            foreach (string files in Directory.GetFiles(destination))
            {
                FileInfo fileInfo = new FileInfo(Path.GetFileName(files));
                try
                {
                    if (File.Exists(fileInfo.FullName))
                    {
                    //    fileInfo.Delete();
                    }
                }
                catch (Exception) { }
            }
            // software 7z para descompresión
            string zPath = "7za.exe";
            string arg = string.Format("x \"{0}\" -y -o\"{1}\"", sourceArchive, destination);
            ProcessStartInfo pro = new ProcessStartInfo();
            pro.WindowStyle = ProcessWindowStyle.Hidden;
            pro.FileName = zPath;
            pro.Arguments = arg;
            //Utils.writeLog(arg, "7za arg:");
            if (System.Environment.OSVersion.Version.Major >= 6)
            {
                // ejecuta un proceso como administrator sin Prompt de windows
                pro.UseShellExecute = false;
                pro.CreateNoWindow = true;
                pro.RedirectStandardOutput = true;
                pro.Verb = "runas";
            }
            try
            {
                Process x = Process.Start(pro);
                x.WaitForExit();
                // se asegura que la aplicación se ha descargado de memoria para borrar el comprimido
                while (!x.HasExited)
                {
                    Thread.Sleep(100);
                }
                // borra la carpeta temporal
                Directory.Delete(pathTmp, true);
            }
            catch (System.Exception Ex)
            {
                Utils.writeLog(Ex.Message, "7za:");
                Console.WriteLine(Ex.Message);
            }
            finally {
                downloaded = false;
            }
        }
    }
}
